from Products.Silva import mangle
from Products.Formulator.Errors import ValidationError, FormValidationError
from Products.Silva.i18n import translate as _

request = context.REQUEST
model = request.model
view = context

curset = request.get('cur_set',None)
request.set('styleset',curset)
if not curset:
    return view.tab_edit(message_type="error",message="Can't find the current style set, unable to save.")

form = getattr(view.aq_explicit,curset)
if form.meta_type != 'Filesystem Formulator Form':
    return view.tab_edit(message_type="error",message="Invalid Style Set." + str(form.meta_type))
    
try:
    result = form.validate_all(request)
except FormValidationError, e:
    return view.tab_edit(message_type="error", message=context.render_form_errors(e))

try:
    model.save_styles(curset,result)
except AttributeError, e:
    return view.tab_edit(message_type="error", message=str(e))
model.sec_update_last_author_info()

msg = ''
action = request.get('submit','change')
if action == 'change':
    if not request.has_key('new_set'):
        return view.tab_edit(message_type="error",message="Invalid Style Set. Unable to change set.")
    request.set('styleset',request['new_set'])
    msg = 'Style Set changed.'
else:
    msg = 'Style Set "%s" was saved.'%form.name
    
msg_type = 'feedback'

return view.tab_edit(message_type=msg_type, message=msg)
